'use strict';

function objMPOptions() {
  var dls, MD, DE, auto, exts, curext, addext, delext, iqdialog;
  var iqshowdialog, iqdb, iqda, iqtodisk;
  var icept, nicept;
  var DefDL = MPIntComm.getPref('DefDL', 'MD');
  var AutoStart = MPIntComm.getPref('AutoStart', false);
  var InterceptKey = MPIntComm.getPref('InterceptKey', 2);
  var DontIntercept = MPIntComm.getPref('DontIntercept', false);
  var ShowIQDlg = MPIntComm.getPref('ShowIQDlg', false);
  var ShowIQDlg2 = MPIntComm.getPref('ShowIQDlg2', 0);
  var IQToDisk = MPIntComm.getPref('IQToDisk', false);
  var AccTypes;

  this.mpintLoad = function() {
    dls = document.getElementById('downloaders');
    MD = document.getElementById('MD');
    DE = document.getElementById('DE');
    auto = document.getElementById('auto');
    exts = document.getElementById('exts');
    curext = document.getElementById('curext');
    addext = document.getElementById('addext');
    delext = document.getElementById('delext');
    iqdialog = document.getElementById('iqdialog');
    iqshowdialog = document.getElementById('iqshowdialog');
    iqdb = document.getElementById('iqdb');
    iqda = document.getElementById('iqda');
    iqtodisk = document.getElementById('iqtodisk');
    icept = document.getElementById('intercept');
    nicept = document.getElementById('dontintercept');
    MPIntComm.SetEnabled(MD, MPIntComm.IsMD);
    MPIntComm.SetEnabled(DE, MPIntComm.IsDE);
    if (DefDL == 'DE')
      dls.selectedIndex = 1;
    auto.checked = AutoStart;
    icept.selectedIndex = InterceptKey;
    nicept.checked = DontIntercept;

    if (!MPIntComm.IsMD && !MPIntComm.IsDE
     && !MPIntComm.IsOE && !MPIntComm.IsIQ) {
      document.getElementById('optsdeck').selectedIndex = 1;
    } else {
      if (!MPIntComm.IsMD && !MPIntComm.IsDE) {
        document.getElementById('dwnldeck').selectedIndex = 1;
        if (MPIntComm.IsIQ) {
          document.getElementById('tabs').selectedIndex = 1;
        } else {
          document.getElementById('tabs').selectedIndex = 2;
        }
      }
      if (!MPIntComm.IsIQ)
        document.getElementById('iqdeck').selectedIndex = 1;
      if (!MPIntComm.IsOE)
        document.getElementById('oedeck').selectedIndex = 1;
    };
    AccTypes = MPIntComm.GetExts();
    let len = AccTypes.length;
    if (len > 0) {
      for (let i = 0; i < len; i++)
        exts.appendItem(AccTypes[i], AccTypes[i]);
      if (MPIntComm.IsMD || MPIntComm.IsDE)
        exts.selectedIndex = 0;
    }

    iqdialog.checked = ShowIQDlg;
    MPIntComm.SetEnabled(iqdb, iqdialog.checked);
    MPIntComm.SetEnabled(iqda, iqdialog.checked);
    iqshowdialog.selectedIndex = ShowIQDlg2;
    iqtodisk.checked = IQToDisk;
  }

  this.mpintAccept = function() {
    if ((DefDL == 'MD') && (dls.selectedIndex == 1)) {
      MPIntComm.setPref('DefDL', 'DE')
    } else if ((DefDL == 'DE') && (dls.selectedIndex == 0)) {
      MPIntComm.setPref('DefDL', 'MD')
    };
    if (auto.checked != AutoStart)
      MPIntComm.setPref('AutoStart', auto.checked);
    if (icept.selectedIndex != InterceptKey)
      MPIntComm.setPref('InterceptKey', icept.selectedIndex);
    if (nicept.checked != DontIntercept)
      MPIntComm.setPref('DontIntercept', nicept.checked);

    if (MPIntComm.IsMD || MPIntComm.IsDE) {
      MPIntComm.AccTypes = AccTypes;
      MPIntComm.SaveExts();
    };

    if (iqdialog.checked != ShowIQDlg)
      MPIntComm.setPref('ShowIQDlg', iqdialog.checked);
    if (iqshowdialog.selectedIndex != ShowIQDlg2)
      MPIntComm.setPref('ShowIQDlg2', iqshowdialog.selectedIndex);
    if (iqtodisk.checked != IQToDisk)
      MPIntComm.setPref('IQToDisk', iqtodisk.checked);

    MPIntComm.SavePrefs();

    return true;
  }

  this.ExtChanged = function() {
    var newext = curext.value.trim().toLowerCase();
    var IsExt = false;
    if (newext) {
      var len = AccTypes.length;
      for (let i = 0; i < len; i++) {
        if (newext == AccTypes[i]) {
          IsExt = true;
          break;
        }
      }
    } else
      IsExt = true;
    MPIntComm.SetEnabled(addext, !IsExt);
  }

  this.AddExt = function() {
    var newext = curext.value.trim().toLowerCase();
    AccTypes.push(newext);
    AccTypes.sort();
    var len = exts.getRowCount();
    var ind = len;
    for (let i = 0; i < len; i++) {
      if (newext < exts.getItemAtIndex(i).value) {
        ind = i;
        break;
      }
    }
    if (ind == len)
      exts.appendItem(newext, newext);
    else
      exts.insertItemAt(ind, newext, newext);
    exts.ensureIndexIsVisible(ind);
    exts.selectedIndex = ind;
    this.ExtChanged();
  }

  this.DelExt = function() {
    var ni, si = exts.selectedIndex;
    AccTypes.splice(si, 1);
    if (si == (exts.getRowCount() - 1))
      ni = si - 1;
    else
      ni = si;
    exts.removeItemAt(si);
    if (ni >= 0)
      exts.selectedIndex = ni;
    this.ExtChanged();
  }

  this.selExtChanged = function() {
    if (MPIntComm.IsMD || MPIntComm.IsDE)
      MPIntComm.SetEnabled(delext, exts.selectedCount > 0);
  }

  this.ChangeShowIQDlg = function() {
    MPIntComm.SetEnabled(iqdb, iqdialog.checked);
    MPIntComm.SetEnabled(iqda, iqdialog.checked);
  }
}

if (!MPOptions) {
  MPIntComm.init();
  var MPOptions = new objMPOptions();
};
